{***************************************************************************}
{  Date: 19.01.97                                            Time: 17:30:40 }
{  Copyright (c)1996-1997                                                   }
{   by Dr.Plass                                               TFindProc1.0 }
{                                                                           }
{                                              for DELPHI 2, Win95 (Not NT!)}
{  feel free to contact me:                                                 }
{  Peter.Plass@FH-Zwickau.de                                                }
{  http://www.fh-zwickau.de/~pp/tm.htm                                      }
{                                                                           }
{  All Rights Reserved.                                                     }
{  This component can be freely used and distributed in commercial and      }
{  private environments, provided this notice is not modified in any way.   }
{                                                                           }
{  used:                                                                    }
{  ToolHelp32 v1.00  Copyright 1996 by Brad Stowers                         }
{                                                                           }
{***************************************************************************}
//
//
//  Methods:
//
//   procedure GetProcessInfo;
//    function GetP_CountUsage(idx : Integer):DWORD;
//    function GetP_ID(idx : Integer): DWORD;
//    function GetP_defHeap(idx : Integer): DWORD;
//    function GetP_ModuleID(idx : Integer): DWORD;
//    function GetP_CountThreads(idx : Integer): DWORD;
//    function GetP_ParentPID(idx : Integer): DWORD;
//    function GetP_Priority(idx : Integer): LongInt;
//    function GetP_dwFlags(idx : Integer): DWORD;
//    function GetP_ExePath(idx : Integer): String;

//  procedure GetModuleInfo(ProcID : DWORD);
//    function GetM_ModuleID(idx : Integer):DWORD;
//    function GetM_ProcessID(idx : Integer):DWORD;
//    function GetM_GlblcntUsage(idx : Integer):DWORD;
//    function GetM_ProccntUsage(idx : Integer):DWORD;
//    function GetM_modBaseSize(idx : Integer):DWORD;
//    function GetM_hModule(idx : Integer):HMODULE;
//    function GetM_szExePath(idx : Integer):string;

//  e.g.: whdl := ProcList1.GetP_CountUsage(ListBox1.ItemIndex);
//
//  Properties:
//
//  ModuleList : TStringList ;
//  ProcessList: TStringList ;
//

unit FFindProc;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FindWin, FindProc, StdCtrls, Buttons, FileLbl;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    ListBox1: TListBox;
    ListBox2: TListBox;
    BitBtn2: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    ProcList1: TProcList;
    BitBtn3: TBitBtn;
    Label13: TFileLabel;
    Label21: TFileLabel;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListBox2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
 ListBox1.Clear;
 ListBox2.Clear;

 Label3.Caption := ''; Label14.Caption :='';
 Label5.Caption := 'click an item for process information';
 Label6.Caption := ''; Label7.Caption  := '';
 Label8.Caption := ''; Label9.Caption  := '';
 Label10.Caption:= ''; Label11.Caption := '';
 Label12.Caption:= ''; Label13.Filename:= '';
 Label4.Caption := ''; Label15.Caption := '';

 Label16.Caption:= ''; Label17.Caption := '';
 Label19.Caption:= '';
 Label20.Caption:= ''; Label21.Filename:= '';


 with ProcList1 do begin
  GetProcessInfo;
  ListBox1.Items.Assign(ProcessList);
  Label3.Caption := IntToStr(ProcessList.Count)+ ' running processes found';
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Caption := ProcList1.About;
 BitBtn1Click(Sender);
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
 close;
end;

procedure TForm1.ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (ListBox1.Items.count < 1) OR (ListBox1.ItemIndex < 0) then exit;
  ListBox2.Clear;

  Label14.Caption := 'click an item for module information';
  Label15.Caption := '';   Label16.Caption := '';
  Label17.Caption := '';   
  Label19.Caption := '';   Label20.Caption := '';
  Label21.Filename:= '';

 with ProcList1 do begin
  Label5.Caption := 'CntUsage: '  + IntToStr(GetP_CountUsage(ListBox1.ItemIndex));
  Label6.Caption := 'ProcessID: ' + IntToHex(GetP_ID(ListBox1.ItemIndex),8);
  Label7.Caption := 'DefHeapID: ' + IntToHex(GetP_defHeap(ListBox1.ItemIndex),8);
  Label8.Caption := 'ModuleID: '  + IntToHex(GetP_ModuleID(ListBox1.ItemIndex),8);
  Label9.caption := 'CntThreads: '+ IntToStr(GetP_CountThreads(ListBox1.ItemIndex));
  Label10.caption:= 'ParentID: '  + IntToHex(GetP_ParentPID(ListBox1.ItemIndex),8);
  Label11.caption:= 'Priority: '  + IntToStr(GetP_Priority(ListBox1.ItemIndex));
  Label12.Caption:= 'dwFlags: '   + IntToStr(GetP_dwFlags(ListBox1.ItemIndex));
  Label13.Filename:= 'Path: '      + GetP_ExePath(ListBox1.ItemIndex);

  GetModuleInfo(GetP_ID(ListBox1.ItemIndex));
  ListBox2.Items.Assign(ModuleList);

  Label4.Caption := IntToStr(ModuleList.Count)+ ' module(s) found';
 end;
end;

procedure TForm1.ListBox2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if (ListBox2.Items.count < 1) OR (ListBox2.ItemIndex < 0) then exit;
 with ProcList1 do begin
  Label14.Caption := 'ModuleID: '   + IntToHex(GetM_ModuleID(ListBox2.ItemIndex),8);
  Label15.Caption := 'ProcessID: '  + IntToHex(GetM_ProcessID(ListBox2.ItemIndex),8);
  Label16.Caption := 'GlblCntUse: ' + IntToStr(GetM_GlblcntUsage(ListBox2.ItemIndex));
  Label17.Caption := 'ProcCntUse: ' + IntToStr(GetM_ProccntUsage(ListBox2.ItemIndex));
  Label19.caption := 'modBaseSize: '+ IntToStr(GetM_modBaseSize(ListBox2.ItemIndex));
  Label20.caption := 'hModule: '    + IntToHex(GetM_hModule(ListBox2.ItemIndex),8);
  Label21.Filename:= 'Path: '       + GetM_szExePath(ListBox2.ItemIndex);
 end;
end;
procedure TForm1.BitBtn3Click(Sender: TObject);
begin
 MessageDlg('Demosoftware'+ #10#13+
            'zur Komponente: TFindProc1.0          '+ #10#13+ #10#13+
            ' 1997 by Dr.Plass                   '+ #10#13+
            'Peter.Plass@fh-zwickau.de            '+ #10#13+
            'http://www.fh-zwickau.de/~pp/tm.htm  ',
             mtInformation, [mbOk],0);
end;

end.
